org.apache.xpath.patterns

## Class StepPattern

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.patterns.NodeTest
    - - org.apache.xpath.patterns.StepPattern

All Implemented Interfaces:
  java.io.Serializable, SourceLocator, SubContextList, ExpressionNode, ExpressionOwner, XPathVisitable

Direct Known Subclasses:
  ContextMatchStepPattern, FunctionPattern

    public class StepPattern
    extends NodeTest
    implements SubContextList, ExpressionOwner

This class represents a single pattern match step.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

### Field Summary

### Fields inherited from class org.apache.xpath.patterns.NodeTest

`SCORE_NODETEST, SCORE_NONE, SCORE_NSWILD, SCORE_OTHER, SCORE_QNAME, SHOW_BYFUNCTION, SUPPORTS_PRE_STRIPPING, WILD`

### Constructor Summary

Constructors
Constructor and Description
`StepPattern(int whatToShow, int axis, int axisForPredicate)` Construct a StepPattern that doesn't test for node names.
`StepPattern(int whatToShow, java.lang.String namespace, java.lang.String name, int axis, int axisForPredicate)` Construct a StepPattern that tests for namespaces and node names.

### Method Summary

Methods
`void` `calcScore()` Static calc of match score.
`void` `calcTargetString()` Calculate the local name or psuedo name of the node that this pattern will test, for hash table lookup optimization.
`void` `callVisitors(ExpressionOwner owner, XPathVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
`boolean` `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`XObject` `execute(XPathContext xctxt)` Execute this pattern step, including predicates.
`XObject` `execute(XPathContext xctxt, int currentNode)` Execute this pattern step, including predicates.
`XObject` `execute(XPathContext xctxt, int currentNode, DTM dtm, int expType)` Execute an expression in the XPath runtime context, and return the result of the expression.
`void` `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`int` `getAxis()` Get the axis that this step follows.
`Expression` `getExpression()` Get the raw Expression object that this class wraps.
`int` `getLastPos(XPathContext xctxt)` Get the count of the nodes that match the test, which is the proximity position of the last node that can pass this test in the sub context selection.
`double` `getMatchScore(XPathContext xctxt, int context)` Get the match score of the given node.
`Expression` `getPredicate(int i)` Get a predicate expression.
`int` `getPredicateCount()` Get the number of predicates for this match pattern step.
`Expression[]` `getPredicates()` Set the list of predicate expressions for this pattern step.
`int` `getProximityPosition(XPathContext xctxt)` Get the proximity position index of the current node based on this node test.
`StepPattern` `getRelativePathPattern()` Get the reference to nodetest and predicate for parent or ancestor.
`java.lang.String` `getTargetString()` Get the local name or psuedo name of the node that this pattern will test, for hash table lookup optimization.
`void` `setAxis(int axis)` Set the axis that this step should follow.
`void` `setExpression(Expression exp)` Set the raw expression object for this object.
`void` `setPredicates(Expression[] predicates)` Set the predicates for this match pattern step.
`void` `setRelativePathPattern(StepPattern expr)` Set the reference to nodetest and predicate for parent or ancestor.
`java.lang.String` `toString()` Get the string represenentation of this step for diagnostic purposes.

### Methods inherited from class org.apache.xpath.patterns.NodeTest

`debugWhatToShow, getDefaultScore, getLocalName, getNamespace, getNodeTypeTest, getStaticScore, getWhatToShow, initNodeTest, initNodeTest, setLocalName, setNamespace, setStaticScore, setWhatToShow`

### Methods inherited from class org.apache.xpath.Expression

`asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### StepPattern

    public StepPattern(int whatToShow,
               java.lang.String namespace,
               java.lang.String name,
               int axis,
               int axisForPredicate)

Construct a StepPattern that tests for namespaces and node names.

Parameters:
  `whatToShow` - Bit set defined mainly by `NodeFilter`.
  `namespace` - The namespace to be tested.
  `name` - The local name to be tested.
  `axis` - The Axis for this test, one of of Axes.ANCESTORORSELF, etc.
  `axisForPredicate` - No longer used.

#### StepPattern

    public StepPattern(int whatToShow,
               int axis,
               int axisForPredicate)

Construct a StepPattern that doesn't test for node names.

Parameters:
  `whatToShow` - Bit set defined mainly by `NodeFilter`.
  `axis` - The Axis for this test, one of of Axes.ANCESTORORSELF, etc.
  `axisForPredicate` - No longer used.

### Method Detail

#### calcTargetString

    public void calcTargetString()

Calculate the local name or psuedo name of the node that this pattern will test, for hash table lookup optimization.

See Also:
  `PsuedoNames`

#### getTargetString

    public java.lang.String getTargetString()

Get the local name or psuedo name of the node that this pattern will test, for hash table lookup optimization.

Returns:
  local name or psuedo name of the node.
See Also:
  `PsuedoNames`

#### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                      int globalsSize)

This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

Overrides:
  `fixupVariables` in class `NodeTest`
Parameters:
  `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).
  `globalsSize` - The number of variables in the global variable area.

#### setRelativePathPattern

    public void setRelativePathPattern(StepPattern expr)

Set the reference to nodetest and predicate for parent or ancestor.

Parameters:
  `expr` - The relative pattern expression.

#### getRelativePathPattern

    public StepPattern getRelativePathPattern()

Get the reference to nodetest and predicate for parent or ancestor.

Returns:
  The relative pattern expression.

#### getPredicates

    public Expression[] getPredicates()

Set the list of predicate expressions for this pattern step.

Returns:
  List of expression objects.

#### canTraverseOutsideSubtree

    public boolean canTraverseOutsideSubtree()

Tell if this expression or it's subexpressions can traverse outside the current subtree. NOTE: Ancestors tests with predicates are problematic, and will require special treatment.

Overrides:
  `canTraverseOutsideSubtree` in class `Expression`
Returns:
  true if traversal outside the context node's subtree can occur.

#### getPredicate

    public Expression getPredicate(int i)

Get a predicate expression.

Parameters:
  `i` - The index of the predicate.
Returns:
  A predicate expression.

#### getPredicateCount

    public final int getPredicateCount()

Get the number of predicates for this match pattern step.

Returns:
  the number of predicates for this match pattern step.

#### setPredicates

    public void setPredicates(Expression[] predicates)

Set the predicates for this match pattern step.

Parameters:
  `predicates` - An array of expressions that define predicates for this step.

#### calcScore

    public void calcScore()

Static calc of match score.

#### execute

    public XObject execute(XPathContext xctxt,
                  int currentNode)
                    throws TransformerException

Execute this pattern step, including predicates.

Overrides:
  `execute` in class `NodeTest`
Parameters:
  `xctxt` - XPath runtime context.
  `currentNode` - The current node context.
Returns:
  `NodeTest.SCORE_NODETEST`, `NodeTest.SCORE_NONE`, `NodeTest.SCORE_NSWILD`, `NodeTest.SCORE_QNAME`, or `NodeTest.SCORE_OTHER`.
Throws:
  `TransformerException`

#### execute

    public XObject execute(XPathContext xctxt)
                    throws TransformerException

Execute this pattern step, including predicates.

Overrides:
  `execute` in class `NodeTest`
Parameters:
  `xctxt` - XPath runtime context.
Returns:
  `NodeTest.SCORE_NODETEST`, `NodeTest.SCORE_NONE`, `NodeTest.SCORE_NSWILD`, `NodeTest.SCORE_QNAME`, or `NodeTest.SCORE_OTHER`.
Throws:
  `TransformerException`

#### execute

    public XObject execute(XPathContext xctxt,
                  int currentNode,
                  DTM dtm,
                  int expType)
                    throws TransformerException

Execute an expression in the XPath runtime context, and return the result of the expression.

Overrides:
  `execute` in class `NodeTest`
Parameters:
  `xctxt` - The XPath runtime context.
  `currentNode` - The currentNode.
  `dtm` - The DTM of the current node.
  `expType` - The expanded type ID of the current node.
Returns:
  The result of the expression in the form of a `XObject`.
Throws:
  `TransformerException` - if a runtime exception occurs.

#### getProximityPosition

    public int getProximityPosition(XPathContext xctxt)

Get the proximity position index of the current node based on this node test.

Specified by:
  `getProximityPosition` in interface `SubContextList`
Parameters:
  `xctxt` - XPath runtime context.
Returns:
  the proximity position index of the current node based on the node test.

#### getLastPos

    public int getLastPos(XPathContext xctxt)

Get the count of the nodes that match the test, which is the proximity position of the last node that can pass this test in the sub context selection. In XSLT 1-based indexing, this count is the index of the last node.

Specified by:
  `getLastPos` in interface `SubContextList`
Parameters:
  `xctxt` - XPath runtime context.
Returns:
  the count of the nodes that match the test.

#### toString

    public java.lang.String toString()

Get the string represenentation of this step for diagnostic purposes.

Overrides:
  `toString` in class `java.lang.Object`
Returns:
  A string representation of this step, built by reverse-engineering the contained info.

#### getMatchScore

    public double getMatchScore(XPathContext xctxt,
                       int context)
                         throws TransformerException

Get the match score of the given node.

Parameters:
  `xctxt` - The XPath runtime context.
  `context` - The node to be tested.
Returns:
  `NodeTest.SCORE_NODETEST`, `NodeTest.SCORE_NONE`, `NodeTest.SCORE_NSWILD`, `NodeTest.SCORE_QNAME`, or `NodeTest.SCORE_OTHER`.
Throws:
  `TransformerException`

#### setAxis

    public void setAxis(int axis)

Set the axis that this step should follow.

Parameters:
  `axis` - The Axis for this test, one of of Axes.ANCESTORORSELF, etc.

#### getAxis

    public int getAxis()

Get the axis that this step follows.

Returns:
  The Axis for this test, one of of Axes.ANCESTORORSELF, etc.

#### callVisitors

    public void callVisitors(ExpressionOwner owner,
                    XPathVisitor visitor)

Description copied from interface: `XPathVisitable`
This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.

Specified by:
  `callVisitors` in interface `XPathVisitable`
Overrides:
  `callVisitors` in class `NodeTest`
Parameters:
  `owner` - The owner of the visitor, where that path may be rewritten if needed.
  `visitor` - The visitor whose appropriate method will be called.
See Also:
  `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

#### getExpression

    public Expression getExpression()

Description copied from interface: `ExpressionOwner`
Get the raw Expression object that this class wraps.

Specified by:
  `getExpression` in interface `ExpressionOwner`
Returns:
  the raw Expression object, which should not normally be null.
See Also:
  `ExpressionOwner.getExpression()`

#### setExpression

    public void setExpression(Expression exp)

Description copied from interface: `ExpressionOwner`
Set the raw expression object for this object.

Specified by:
  `setExpression` in interface `ExpressionOwner`
Parameters:
  `exp` - the raw Expression object, which should not normally be null.
See Also:
  `ExpressionOwner.setExpression(Expression)`

#### deepEquals

    public boolean deepEquals(Expression expr)

Description copied from class: `Expression`
Compare this object with another object and see if they are equal, include the sub heararchy.

Overrides:
  `deepEquals` in class `NodeTest`
Parameters:
  `expr` - Another expression object.
Returns:
  true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
See Also:
  `Expression.deepEquals(Expression)`